Name:           scilab
Version:        5.3.3
Release:        6%{?dist}
Summary:        Scientific software package for numerical computations

Group:          Applications/Engineering
License:        CeCILL
URL:            http://www.scilab.org/
Source0:        http://www.scilab.org/download/%{version}/scilab-%{version}-src.tar.gz

Patch1:         0001-configure-upstream-patches.patch
Patch2:         0002-Update-saxon-dependency-wrong-version.patch
Patch3:         0003-Remove-Xcos-dependencies-check.patch
Patch4:         0004-fix-javadoc-encoding.patch
Patch5:         0005-autoreconf.patch
# fix rpmlint errors
Patch6:         0006-fix-incorrect-fsf-adress.patch
Patch7:         0007-fix-zero-length.patch
Patch8:         0008-fix-class-path-in-manifest.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# Dependencies are extracted from :
# "http://wiki.scilab.org/Dependencies of Scilab 5.X"

# Mandatory
BuildRequires:  gcc-gfortran

## for dynamic link features
Requires:       gcc
Requires:       gcc-c++
Requires:       gcc-gfortran

# Core
BuildRequires:  libxml2-devel
BuildRequires:  pcre-devel
BuildRequires:  ncurses-devel

# Numerical libraries
# see "http://wiki.scilab.org/Linalg performances"
BuildRequires:  lapack-devel

# GUI/Console
BuildRequires:  jpackage-utils
BuildRequires:  java-devel
BuildRequires:  ant

BuildRequires:  flexdock >= 1.0
BuildRequires:  jogl
BuildRequires:  mesa-libGL-devel

Requires:       flexdock >= 1.0
Requires:       jogl

BuildRequires:  jrosetta >= 1.0.4
Requires:       jrosetta >= 1.0.4

BuildRequires:  apache-commons-logging
BuildRequires:  javahelp2
BuildRequires:  jlatexmath
BuildRequires:  jlatexmath-fop
BuildRequires:  jgraphx
BuildRequires:  fop
BuildRequires:  jeuclid
BuildRequires:  batik
BuildRequires:  xmlgraphics-commons

Requires:       apache-commons-logging
Requires:       javahelp2
Requires:       jlatexmath
Requires:       jlatexmath-fop
Requires:       jgraphx
Requires:       fop
Requires:       jeuclid
Requires:       batik
Requires:       xmlgraphics-commons

# TCL/TK features
BuildRequires:  tcl-devel
BuildRequires:  tk-devel

Requires:       tcl
Requires:       tk

# Modelica
BuildRequires:  ocaml

# Documentation
BuildRequires:  saxon
BuildRequires:  docbook-style-xsl
BuildRequires:  liberation-sans-fonts

Requires:       saxon

# All optional dependencies are needed to provide a full-featured Scilab
BuildRequires:  gettext-devel
BuildRequires:  pvm
BuildRequires:  fftw-devel
BuildRequires:  matio-devel
BuildRequires:  suitesparse-devel
BuildRequires:  hdf5-devel
BuildRequires:  jhdf5

Requires:       pvm
# hdf5 does not bump soname but check at runtime
Requires:       hdf5 = %{_hdf5_version}
Requires:       jhdf5

# Specific dependencies for packaging purpose
BuildRequires:  desktop-file-utils

%description
Scilab is the free software for numerical computation providing a powerful
computing environment for engineering and scientific applications. It
includes hundreds of mathematical functions. It has a high level programming
language allowing access to advanced data structures, 2-D and 3-D graphical
functions.

%package devel
Group:          Applications/Engineering
License:        CeCILL

Summary:        Scientific software package for numerical computations (include files)

Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
Scilab is the free software for numerical computation providing a powerful
computing environment for engineering and scientific applications. It
includes hundreds of mathematical functions. It has a high level programming
language allowing access to advanced data structures, 2-D and 3-D graphical
functions.

This package provide include files for Scilab.

%package doc
Group:          Documentation
License:        CeCILL

Summary:        Scientific software package (documentation files)

BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description doc
Scilab is the free software for numerical computation providing a powerful
computing environment for engineering and scientific applications. It
includes hundreds of mathematical functions. It has a high level programming
language allowing access to advanced data structures, 2-D and 3-D graphical
functions.

This package provide documentation files for Scilab.

%package tests
Group:          Applications/Engineering
License:        CeCILL

Summary:        Provides test files for Scilab

BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}
Requires:       testng

%description tests
Scilab is the free software for numerical computation providing a powerful
computing environment for engineering and scientific applications. It
includes hundreds of mathematical functions. It has a high level programming
language allowing access to advanced data structures, 2-D and 3-D graphical
functions.

This package provide test files for Scilab.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# fix incorrect-fsf-adress
%patch6 -p1
# fix zero-length
%patch7 -p1
# fix class-path-in-manifest
%patch8 -p1
# fix spurious-executable-perm
chmod -x modules/scicos_blocks/src/c/*.c modules/scicos_blocks/includes/*.h
# fix file-not-utf8
while read file
do
    iconv -f ISO-8859-1 -t UTF-8 -o $file.new $file && \
    touch -r $file $file.new && \
    mv $file.new $file
done << EOF
COPYING
modules/scicos/macros/scicos_scicos/look_for_text.sci
modules/scicos/macros/scicos_scicos/unhilite_modelica_block.sci
EOF


%build
%configure PVM_ROOT=%{_datadir}/pvm3

make %{?_smp_mflags}
make %{?_smp_mflags} doc

%install
make %{?_smp_mflags} install DESTDIR=%{buildroot}
desktop-file-validate %{buildroot}%{_datadir}/applications/%{name}.desktop
%find_lang %{name}

# Remove more advanced repl, user should use CLI options instead
rm -fr %{buildroot}%{_datadir}/applications/%{name}-*.desktop
# Remove la files
rm -fr %{buildroot}%{_libdir}/%{name}/*.la

# fix non-executable-script
chmod +x %{buildroot}%{_datadir}/%{name}/modules/helptools/bin/*

# Add localized help files to scilab-doc.lang
# adapted from find-lang.sh
# always provide the english help to handle missing localized help pages
find %{buildroot}%{_datadir}/%{name}/modules/helptools/jar -type f -o -type l|sed '
s:'"%{buildroot}"'::
s:\(.*/'"%{name}"'_\)\([^\._]\+\)\(.*\.jar$\):%lang(\2) \1\2\3:
s:^\([^%].*\)::
s:%lang(en) ::
s:%lang(C) ::
/^$/d' >%{name}-doc.lang


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc README_Unix COPYING license.txt
%{_bindir}/*
%{_libdir}/%{name}
%{_datadir}/applications/%{name}.desktop
%{_datadir}/%{name}
# part of scilab-devel
%exclude %{_datadir}/%{name}/contrib
%exclude %{_datadir}/%{name}/tools
# part of scilab-doc
%exclude %{_datadir}/%{name}/modules/helptools/jar/%{name}_*.jar
%exclude %{_datadir}/%{name}/modules/*/examples
%exclude %{_datadir}/%{name}/modules/*/help
%exclude %{_datadir}/%{name}/modules/*/javadoc
# part of scilab-tests
%exclude %{_datadir}/%{name}/modules/*/tests

%files devel
%defattr(-,root,root,-)
%doc README_Unix COPYING license.txt
%{_includedir}/%{name}
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/%{name}/contrib
%{_datadir}/%{name}/tools

%files doc -f %{name}-doc.lang
%defattr(-,root,root,-)
%doc README_Unix COPYING license.txt
%{_datadir}/doc/%{name}-*
%{_datadir}/%{name}/modules/*/examples
%{_datadir}/%{name}/modules/*/help
%{_datadir}/%{name}/modules/*/javadoc

%files tests
%defattr(-,root,root,-)
%doc README_Unix COPYING license.txt
%{_datadir}/%{name}/modules/*/tests

%changelog
* Mon Jan  2 2012 Clément David <c.david86@gmail.com> - 5.3.3-6
- Update classpath.xml due to the flexdock move.

* Mon Dec  5 2011 <c.david86@gmail.com> 5.3.3-5
- Add saxon dependency

* Tue Nov 22 2011 Clément David <c.david86@gmail.com> - 5.3.3-4
- use %{_hdf5_version} to avoid runtime crash

* Wed Nov  9 2011 <c.david86@gmail.com> 5.3.3-3
- Remove dependency on atlas (need only lapack ABI)
- Use noarch package on doc and tests
- Remove ldconfig on post/postun
- add a default font for doc generation
- scilab does not depends on scilab-doc anymore

* Sun Oct 30 2011 <c.david86@gmail.com> 5.3.3-2
- Use rpm auto dependency
- add minimal versions for flexdock and jrosetta

* Sun Oct 30 2011 <c.david86@gmail.com> 5.3.3-1
- First package

